/* qdbusvariant.h DBUS variant struct
 *
 * Copyright (C) 2005 Harald Fernengel <harry@kdevelop.org>
 *
 * Licensed under the Academic Free License version 2.1
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA.
 *
 */

#ifndef QDBUSVARIANT_H
#define QDBUSVARIANT_H

#include "dbus/qdbusmacros.h"
#include "dbus/qdbusdata.h"
// FIXME-QT4 #include <qmetatype.h>
#include <qstring.h>

class QDBUS_EXPORT QDBusVariant
{
public:
    QDBusVariant() {}

    QDBusVariant(const QDBusVariant& other)
    {
        signature = other.signature;
        value = other.value;
    }

    inline bool operator==(const QDBusVariant& other) const
    {
        if (&other == this) return true;

        return signature == other.signature && value == other.value;
    }

    inline bool operator!=(const QDBusVariant& other) const
    {
        if (&other == this) return false;

        return signature != other.signature || value != other.value;
    }

public:
    QString signature;
    QDBusData value;
};
// FIXME-QT4 Q_DECLARE_METATYPE(QDBusVariant)

#endif

